/***************************************************************************
                          App.h  -  description
                             -------------------
    begin                : Sun Dec 10 2000
    copyright            : (C) 2000 by Ryan Phillips
    email                : ryan@trolocsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _APP_H_
#define _APP_H_

#include "App.h"
#include "Image.h"
#include "bool.h"
#include "TileMap.h"
#include <SDL/SDL_ttf.h>

class App
{   
public:
   
   int Run( char *argv[] = 0, SDL_Surface* scr = 0 );
   int Draw();   
   int DrawBG( int tiled );
   int DrawMap();
   int DrawBorder();
   int DrawText();
   int IsLegalMove( int direction );
   int ResetGame();

   int IsDirty() { return dirty; } 
   void SetDirty( int b ) { dirty = b; }

   App(){ dirty = TRUE; }
   ~App() {}
private:
   SDL_Surface *board;
   SDL_Surface *screen;
   SDL_Surface *status;
   TTF_Font    *fntMain;
   
   Image   ImageStore; 
   TileMap MapStore;
   int dirty;
   int MapLengthY, MapLengthX;
   int changed_map, level;
   int pushes;
      
};

#define UP    0
#define DOWN  1
#define LEFT  2
#define RIGHT 3

#endif