/***************************************************************************
                          GFX.h  -  description
                             -------------------
    begin                : Sun Dec 10 2000
    copyright            : (C) 2000 by Ryan Phillips
    email                : ryan@trolocsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _GFX_H_
#define _GFX_H_

#include <map>
#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>


/* absolute value of a */
#define ABS(a)		(((a)<0) ? -(a) : (a))

/* take binary sign of a, either -1, or 1 if >= 0 */
#define SGN(a)		(((a)<0) ? -1 : 1)

enum { KEY_F1, KEY_TAB, KEY_S, KEY_LEFT, KEY_RIGHT, KEY_DOWN, KEY_UP, KEY_SPACE, KEY_ESC };

SDL_Surface* init_graphics( int width, int height, int bpp );
void exit_graphics(void);
int IsKeyDown(int key);
void poll_keyboard();
void SetCaptions( char* Name, char* Icon );
SDL_Surface* bmp2surface( char* bitmapName );
void unlock_graphics( SDL_Surface* buffer );
void lock_graphics( SDL_Surface* buffer);
void drawline( SDL_Surface* buffer, int x1,int y1,int x2,int y2, Uint32 color);
void draw_vertline( SDL_Surface* buffer, Sint16 x, Sint16 y1, Sint32 y2, Uint32 color);
void draw_horzline( SDL_Surface* buffer, Sint16 x1, Sint16 x2, Sint32 y, Uint32 color);
void drawcircle(SDL_Surface* buffer, Sint16 x, Sint16 y, Sint32 r, Uint32 color);

extern int width;
extern int height;
extern int bpp;

#endif