/***************************************************************************
                          Image.h  -  description
                             -------------------
    begin                : Sun Dec 10 2000
    copyright            : (C) 2000 by Ryan Phillips
    email                : ryan@trolocsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef _IMAGE_H_
#define _IMAGE_H_

#include <map>
#include <string>
#include <SDL/SDL.h>

class Image
{
public:
   static std::map< std::string, SDL_Surface* > Images;

public:
   int AddBitmap( char* storeName,  char* filename );
   void FreeImages();
   
   Image();
   ~Image();   
private:      
   
};

#define IMAGE_BG         "BG"
#define IMAGE_PLAYER     "PLAYER"
#define IMAGE_SPACE      "SPACE"
#define IMAGE_BOX        "BOX"
#define IMAGE_BOXFILLED  "BOXFILLED"
#define IMAGE_WALL       "WALL"
#define IMAGE_CROSS      "CROSS"

#define SPACE     ' '
#define WALL      '#'
#define CROSS     '.'
#define PLAYER    '@'
#define PLAYERFILLED '*'
#define BOX       '$'
#define BOXFILLED 'b'

#endif