/***************************************************************************
                          TileMap.h  -  description
                             -------------------
    begin                : Sun Dec 10 2000
    copyright            : (C) 2000 by Ryan Phillips
    email                : ryan@trolocsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef MAP_H_
#define MAP_H_

#define MAXROW		20
#define MAXCOL		20

#include <string>
#include "bool.h"

class TileMap
{
public:
   int ReadMap( int level );
   char GetXY( int x, int y ) { return Map[y][x]; }
   int DebugPrint();

   int GetLimitX() { return limitx; }
   int GetLimitY() { return limity; }
   int GetPlayerX() { return playerx; }
   int GetPlayerY() { return playery; }
   int GetPrev() { return prev; }
   int IsSolved();
      
   void SetBox( char Tile, int x, int y );
   void SetPrev( char Tile ){ prev = Tile; };

   TileMap() {   }   

private:  

   int limitx, limity;   
   int playerx, playery;
   char prev;
   char Map[MAXCOL][MAXROW];

};



#endif