/***************************************************************************
                          TileMap.cpp  -  Handles reading and storing the
                                          sokoban map.
                             -------------------
    begin                : Sun Dec 10 2000
    copyright            : (C) 2000 by Ryan Phillips
    email                : ryan@trolocsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <iostream>
#include <fstream>
#include "TileMap.h"
#include "Image.h"
#include "bool.h"

int TileMap::ReadMap(int level)
{   
  std::ifstream in;
  char *fnam;
  char input[20];
  int y, x, line_length, line_number = 0;
  int max_line_length = 0;
  int max_lines = 0;
  

  short ret = 0;

  for (y = 0; y < MAXROW; y++)
    for (x = 0; x < MAXCOL; x++)
      Map[y][x] = SPACE;

  fnam = new char[ strlen("levels/") + 12 ];
  sprintf( fnam, "%slevel.%d", "levels/", level );

  in.open( fnam );
  if( in.fail() )
  {
      fprintf( stderr, "Bad File: %s\n", fnam );
      exit(1);
  }

  in.getline( input, '\r\n' );      


  while( !in.eof() )
  {      
      line_length = strlen( input );
      
      if( line_length > max_line_length )
         max_line_length = line_length;

      for( int i=0; i<line_length; i++ )
      {         
         Map[ line_number ][i] = input[i];
      }
      memset( input, 0, sizeof(input) );
      line_number++;
      max_lines++;


      in.getline( input, '\r\n' );//, '\r\n' );

      
  }  
      

  limitx = max_line_length;
  limity = max_lines;

  for (y = 0; y < MAXROW; y++)
  {
    for (x = 0; x < MAXCOL; x++)
    {
       if( Map[y][x] == PLAYER )
       {
          playerx = x;
          playery = y;
          break;
       } 
    }
  }  

  delete[] fnam;
  return (ret);
}

void TileMap::SetBox( char Tile, int x, int y )
{      
   Map[y][x] = Tile;
   if( Tile == PLAYER )
   {
      playerx = x;
      playery = y;
   }
}

int TileMap::DebugPrint()
{  
   int i,j;

   for( j=0; j<20; j++ )
   {
      for( i=0; i<20; i++ )
      {
         std::cout << Map[j][i];
      }
      std::cout << std::endl;
   }
   return 0;
} 

int TileMap::IsSolved()
{
   int i,j;

   for( j=0; j<20; j++ )
   {
      for( i=0; i<20; i++ )
      {
         if( Map[j][i] == BOX )
            return FALSE;
      }      
   }
   return TRUE;
}

